package edu.travel.tenant.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "edu_tenant")
public class EduTenant {
    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private Long id;

    /**
     * 姓
     */
    @TableField(value = "tenant_surname")
    private String tenantSurname;

    /**
     * 名
     */
    @TableField(value = "tenant_name")
    private String tenantName;

    /**
     * 性别 0男 1女
     */
    @TableField(value = "tenant_sex")
    private Integer tenantSex;

    /**
     * 头像
     */
    @TableField(value = "tenant_avatar")
    private String tenantAvatar;

    /**
     * 手机号
     */
    @TableField(value = "tenant_phone")
    private String tenantPhone;

    /**
     * 地区区号
     */
    @TableField(value = "tenant_area")
    private String tenantArea;

    /**
     * 生日日期
     */
    @TableField(value = "tenant_birthday")
    private Date tenantBirthday;

    /**
     * 微信小程序openid
     */
    @TableField(value = "tenant_open_id")
    private String tenantOpenId;

    /**
     * 微信小程序unionid
     */
    @TableField(value = "tenant_unionid")
    private String tenantUnionid;

    /**
     * 项目名称
     */
    @TableField(value = "project")
    private String project;

    /**
     * 创建时间
     */
    @TableField(value = "create_time")
    private Date createTime;

    /**
     * 创建用户id
     */
    @TableField(value = "create_user_id")
    private Long createUserId;

    /**
     * 更新时间
     */
    @TableField(value = "update_time")
    private Date updateTime;

    /**
     * 更新用户id
     */
    @TableField(value = "update_user_id")
    private Long updateUserId;

    /**
     * 逻辑删除标记
     */
    @TableField(value = "delete_flag")
    private Integer deleteFlag;

    /**
     * 现实名
     */
    @TableField(value = "show_name")
    private String showName;

    /**
     * 用户状态
     */
    @TableField(value = "user_status")
    private Integer userStatus;
}