package edu.travel.tenant.service.impl;

import cn.hutool.core.lang.Snowflake;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import edu.travel.tenant.service.ITenantService;
import org.apache.commons.lang3.StringUtils;
import edu.travel.resp.BaseResponse;
import edu.travel.tenant.entity.EduTenant;
import edu.travel.tenant.entity.SysRole;
import edu.travel.tenant.service.ISysRoleService;
import edu.travel.service.SysServiceImpl;
import edu.travel.tenant.mapper.SysRoleMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * ISysRoleServiceImpl 类。
 * <p>
 * 描述：
 *
 * @author huangwenwen
 * @date 2025/2/6
 */

@Service
public class ISysRoleServiceImpl extends SysServiceImpl<SysRoleMapper, SysRole> implements ISysRoleService {

    @Autowired
    private ISysRoleService sysRoleService;
    @Autowired
    private ITenantService tenantService;

    @Override
    public Boolean add(SysRole sysRole, EduTenant principal) {
        if (principal == null) {
            throw new RuntimeException("身份验证失败");
        }
        if (sysRole != null && StringUtils.isNotEmpty(sysRole.getName())) {
            int count = sysRoleService.count(new LambdaQueryWrapper<SysRole>()
                    .eq(SysRole::getName, sysRole.getName()));
            if (count != 0) {
                throw new RuntimeException("该角色已存在");
            }
            sysRole.setId(new Snowflake(1, 1).nextId());
            sysRole.setProject(principal.getProject());
            sysRole.setCreateUserId(principal.getId().toString());
            sysRole.setUpdateUserId(principal.getId().toString());
            boolean save = sysRoleService.save(sysRole);
            return save;
        }
        return false;
    }
}
